package de.lmu.ifi.pms.cep.compilation;

import org.simpleframework.xml.Attribute;
import org.simpleframework.xml.Root;

@Root(name="compiler")
public abstract class CompilerFactory<SourceProgramType, DestinationProgramType> {
	
	@Attribute(name="iri", required=true)
	public final String identifier;
	
	public final Class<SourceProgramType> sourceProgramType;
	
	public final Class<DestinationProgramType> destinationProgramType;	
	
	public CompilerFactory(final Class<SourceProgramType> sourceProgramType, final Class<DestinationProgramType> destinationProgramType, final String identifier) {
		super();
		this.sourceProgramType = sourceProgramType;
		this.destinationProgramType = destinationProgramType;
		this.identifier = identifier;
	}

	public abstract Compiler<SourceProgramType, DestinationProgramType> make();

}
