lexer grammar DuraLexer;

@header {
package de.lmu.ifi.pms.cep.dura.compiler.antlr;
}

ID
  : ('a'..'z' | 'A'..'Z') ('a'..'z' | 'A'..'Z' | '0'..'9' | '-' | '_')*
  ;

NUMBER
  : ('0'..'9')+ '.' ('0'..'9')+ Exponent? ('d' | 'f')?
  | ('0'..'9')+ Exponent ('d' | 'f')?
  | ('0'..'9')+ ('d' | 'f' | 'l')?
  ;

fragment
Exponent
  : ('e' | 'E') ('+' | '-')? ('0'..'9')+ 
  ;

STRING 
  : '"' (EscapeSequence | ~('\\' | '"'))* '"'
  ;

fragment
EscapeSequence
  : '\\' ('b' | 't' | 'n' | 'f' | 'r' | '\"' | '\'' | '\\')
  ;

COMMENT
  : '//' ~('\n' | '\r')* '\r'? '\n' {$channel=HIDDEN;}
  | '/*' (options {greedy=false;} : .)* '*/' {$channel=HIDDEN;}
  ;

WS
  : (' ' | '\t' | '\r' | '\n') {$channel=HIDDEN;}
  ; 