package de.lmu.ifi.pms.cep.dura.compiler.dura.desugaring;

import org.antlr.runtime.tree.CommonTree;

public class Desugarer {
	public static void desugar(CommonTree tree) {
		Transformation[] transformations = new Transformation[]{
				new TermNormalization(),
				
				// new ConstantDefinitions(),
				
				// Pseudo-transformation as of Oct. 23
				new TypeDefinitions(),
				// Pseudo-transformation
				new SchemaAnalysis(),
				
				// First pass/time to handle all initial matchings...
				// Not required anymore as of Oct. 23
				// new SchemaMatching(),
				
				new AnonymousActionCompositions(),
				
				new ReactiveRuleActionExecutionProvenanceInfoAugmentation(),
				
				new ActionSpecifications(),
				
				new ReactiveRuleSimplification(),
				
				// Second pass/time to handle all initial matchings that are contained in
				// new rules created by the previous transformations ...
				// new SchemaMatching(),
				
				new AnonymousQueryIdentifiers(),
				new ComplexSubqueries(),
				new ExistentialQuantification(),
				
				new AggregationAnywhere(),
				new SpecialExpressionsInHeadTerm(),
				
				// new HiddenBindingsAfterGrouping()
		};
		
		for (int i = 0; i < transformations.length; i++) {
			System.out.println("Transformation " + i + ": " + transformations[i].getClass().getSimpleName());
		}
		System.out.println();
		
		for (Transformation transformation : transformations) {
			transformation.apply(tree);
		}
	}
}
