package de.lmu.ifi.pms.cep.dura.compiler.durac.formula_transformations;

import de.lmu.ifi.pms.cep.dura.compiler.durac.collections.ConstDefinitions;
import de.lmu.ifi.pms.cep.dura.compiler.durac.collections.Preamble;
import de.lmu.ifi.pms.cep.dura.compiler.exceptions.DuraCExceptionWrapper;
import de.lmu.ifi.pms.cep.dura.compiler.exceptions.DuraUnspecificCompliationException;
import de.lmu.ifi.pms.cep.tsa.conditions.AtomicTerm;
import de.lmu.ifi.pms.cep.tsa.conditions.NamedConstant;
import de.lmu.ifi.pms.cep.tsa.conditions.Term;
import de.lmu.ifi.pms.java.util.adaption.Adapter;

class MapRelpaceConstants implements Adapter<AtomicTerm<?>, Term<?>> {

	public final ConstDefinitions constants;
	public final Preamble preamble;
	
	public MapRelpaceConstants(final ConstDefinitions constants, final Preamble preamble) {
		this.constants = constants;
		this.preamble = preamble;
	}

	@Override
	public Term<?> adapt(final AtomicTerm<?> source) {
		if (source instanceof NamedConstant) {
			NamedConstant constant = (NamedConstant) source;
			
			try {
				return this.constants.getTerm(constant.name, this.preamble);
			} catch (DuraUnspecificCompliationException e) {
				throw new DuraCExceptionWrapper(e);
			}
		}
		
		return source;
	}

}
