package de.lmu.ifi.pms.cep.dura.compiler.durac.queries;

import java.util.HashMap;
import java.util.Map;

import de.lmu.ifi.pms.cep.dura.compiler.durac.collections.UnambiguousQueryVariables;
import de.lmu.ifi.pms.cep.tsa.TSA_Expression;

public class CompositeEventQuery {
	protected TSA_Expression expression;
	
	protected UnambiguousQueryVariables variables;
	
	protected Map<String, String> identifierMapping;

	protected CompositeEventQuery() { }
	
	public CompositeEventQuery(TSA_Expression expression, UnambiguousQueryVariables variables) {
		this(expression, variables, new HashMap<String, String>());
	}
	
	public CompositeEventQuery(TSA_Expression expression, UnambiguousQueryVariables variables, Map<String, String> identifierMapping) {
		this.expression = expression;
		this.variables = variables;
		this.identifierMapping = identifierMapping;
	}

	public Map<String, String> getIdentifierMapping() {
		return identifierMapping;
	}

	public UnambiguousQueryVariables getVariables() {
		return variables;
	}

	public TSA_Expression getExpression() {
		return expression;
	}
}
