package de.lmu.ifi.pms.cep.dura.compiler.durac.token_mappings;

import static de.lmu.ifi.pms.cep.tsa.schema.TemporalStreamSchemaTypeID.ACTION;
import static de.lmu.ifi.pms.cep.tsa.schema.TemporalStreamSchemaTypeID.EVENT;
import static de.lmu.ifi.pms.cep.tsa.schema.TemporalStreamSchemaTypeID.STATE;

import org.antlr.runtime.tree.Tree;

import de.lmu.ifi.pms.cep.dura.compiler.antlr.DuraCLexer;
import de.lmu.ifi.pms.cep.tsa.schema.TemporalStreamSchemaTypeID;
import de.lmu.ifi.pms.java.util.map.fixed.FixedArrayNavigableMap;


public class DuraStreamTypesMapping {

	private final static FixedArrayNavigableMap<Integer, TemporalStreamSchemaTypeID> fromTokenMap = new FixedArrayNavigableMap<Integer, TemporalStreamSchemaTypeID>(
		new                    Integer[]{ DuraCLexer.EVENT, DuraCLexer.EVENT_QUERY, DuraCLexer.STATEFUL_OBJECT, DuraCLexer.STATE_QUERY, DuraCLexer.ACTION}, 
		new TemporalStreamSchemaTypeID[]{            EVENT,                  EVENT,                      STATE,                  STATE,            ACTION}
	);
	
	private final static FixedArrayNavigableMap<String, TemporalStreamSchemaTypeID> fromIdentifierMap = new FixedArrayNavigableMap<String, TemporalStreamSchemaTypeID>(
			new                     String[]{ "event", "state", "action"}, 
			new TemporalStreamSchemaTypeID[]{   EVENT,   STATE,   ACTION}
		);

	public static TemporalStreamSchemaTypeID fromToken(final Tree token) {
		assert(token.getType() != DuraCLexer.IDENTIFIER);
		
		return fromTokenMap.get(token.getType());
	}
	
	public static TemporalStreamSchemaTypeID fromIdentifierPrefix(final String prefix) {
		return fromIdentifierMap.get(prefix);
	}
}