package de.lmu.ifi.pms.cep.dura.compiler.exceptions;

import java.io.File;

import de.lmu.ifi.pms.cep.dura.compiler.antlr.utils.DuraImplicitTree;
import de.lmu.ifi.pms.cep.dura.compiler.antlr.utils.DuraTree;
import de.lmu.ifi.pms.cep.tsa.exceptions.TSA_Exception;

public class DuraCompilationException extends RuntimeException {
	
	DuraCompilationException(final String msg) {
		super(msg);
	}
	
	public DuraCompilationException(final String msg, final String positionDescription) {
		super(String.format("%s\n%s", msg, positionDescription));
	}
	
	public DuraCompilationException(final TSA_Exception e, final DuraTree cause) {
		this(e.getSimpleMessage(), cause.getPositionDescription());
	}

	public DuraCompilationException(final Throwable e, final DuraTree cause) {
		this(e.getMessage(), cause.getPositionDescription());
	}

	public DuraCompilationException(final String msg, final DuraTree cause) {
		this(msg, cause.getPositionDescription());
	}
	
	public DuraCompilationException(final String msg, final String filename, final int line) {
		this(msg, String.format("\tat %s:%d", new File(filename).getAbsolutePath(), line));
	}
	
}
