package de.lmu.ifi.pms.cep.event_mill.configuration;

import java.sql.Connection;
import java.sql.Driver;
import java.sql.DriverPropertyInfo;
import java.sql.SQLException;
import java.sql.SQLFeatureNotSupportedException;
import java.util.Properties;

public class DriverWrapper implements Driver {
	private final Driver driver;
	
	public DriverWrapper(final Driver d) {
		this.driver = d;
	}
	 
	@Override
	public boolean acceptsURL(final String u) throws SQLException {
		return this.driver.acceptsURL(u);
	}
	@Override
	public int getMajorVersion() {
		return this.driver.getMajorVersion();
	}
	@Override
	public int getMinorVersion() {
		return this.driver.getMinorVersion();
	}
	@Override
	public boolean jdbcCompliant() {
		return this.driver.jdbcCompliant();
	}
	@Override
	public Connection connect(final String url, final Properties info) throws SQLException{
		return this.driver.connect(url, info);
	}
	@Override
	public DriverPropertyInfo[] getPropertyInfo(final String url, final Properties info) throws SQLException{
		return this.driver.getPropertyInfo(url, info);
	}
	@Override
	public java.util.logging.Logger getParentLogger()  throws SQLFeatureNotSupportedException{
		return this.driver.getParentLogger();
	}
}