package de.lmu.ifi.pms.cep.event_mill.configuration;

import org.simpleframework.xml.Attribute;
import org.simpleframework.xml.Path;
import org.simpleframework.xml.Root;

@Root(name="configuration")
public abstract class SQL_ConnectionConfiguration {
	
	@Path(value="server")
	@Attribute(name="url")
	public final String serverUrl;
	@Path(value="database")
	@Attribute(name="name", required=false)
	public final String database;
	
	@Path(value="catalog")
	@Attribute(name="name", required=false)
	public final String catalog;
	
	public final boolean autoCommitMode;
	
	@Attribute(name="auto-commit-mode", required=false)
	Boolean getAutoCommitMode(){
		return this.autoCommitMode;
	}
	
	public final boolean usePreparedStatements;
	
	@Attribute(name="use-prepared-statements")
	Boolean getUsePreparedStatements(){
		return this.usePreparedStatements;
	}
	
	public SQL_ConnectionConfiguration(final String serverUrl, final String database, final String catalog, final Boolean autoCommitMode, final Boolean usePreparedStatements) {
		super();
		this.serverUrl = serverUrl;
		this.database = database;
		this.catalog = catalog;
		this.autoCommitMode = (autoCommitMode == null ? true : autoCommitMode);
		this.usePreparedStatements = usePreparedStatements;
	}

	public abstract java.util.Properties properties();

}
