package de.lmu.ifi.pms.cep.event_mill.configuration;

import java.util.Properties;

import org.simpleframework.xml.Attribute;
import org.simpleframework.xml.Element;
import org.simpleframework.xml.ElementList;
import org.simpleframework.xml.Path;

import de.lmu.ifi.pms.java.util.map.fixed.FixedArrayNavigableMap;


public class StandardConnectionConfiguration extends SQL_ConnectionConfiguration{
	
	@ElementList(name="properties", entry="property", inline=true, required=false)
	java.util.ArrayList<Property> getProperties(){
		if(this.properties.isEmpty()){
			return null;
		}
		else{
			return Property.serialize(this.properties);
		}
	}
	
	@Element(name="user", required=false)
	public final String user;
	@Element(name="password", required=false)
	public final String password;
	
	public final FixedArrayNavigableMap<String, String> properties;
	
	public StandardConnectionConfiguration(@Path(value="server")@Attribute(name="url") final String serverUrl
			, @Path(value="database")@Attribute(name="name", required=false) final String database
			, @Path(value="catalog")@Attribute(name="name", required=false) final String catalog
			, @Attribute(name="auto-commit-mode", required=false) final Boolean autoCommitMode
			, @Attribute(name="use-prepared-statements") final Boolean usePreparedStatements
			, @Element(name="user", required=false) final String user
			, @Element(name="password", required=false) final String password
			, @ElementList(name="properties", entry="property", inline=true, required=false) final java.util.ArrayList<Property> properties) {
		this(serverUrl, database, catalog, autoCommitMode, usePreparedStatements, user, password, Property.get(properties));
	}

	public StandardConnectionConfiguration(final String serverUrl, final String database, final String catalog, final Boolean autoCommitMode, final Boolean usePreparedStatements, final String user, final String password, final FixedArrayNavigableMap<String, String> properties) {
		super(serverUrl, database, catalog, autoCommitMode, usePreparedStatements);		
		this.user = user;
		this.password = password;
		this.properties = properties;
	}
	
	@Override
	public Properties properties() {
		java.util.Properties properties = new java.util.Properties();
		properties.putAll(this.properties.javaMap());
		if (this.user != null) {
		    properties.put("user", this.user);
		}
		if (this.password != null) {
		    properties.put("password", this.password);
		}
		return properties;
	}

}
