package de.lmu.ifi.pms.cep.event_mill.execution.program;

import org.simpleframework.xml.Root;

import de.lmu.ifi.pms.cep.compilation.CompilerFactory;
import de.lmu.ifi.pms.cep.tsa.DTSA_Program;


@Root(name="stream-buffer-store")
public abstract class StreamBufferStoreFactory<StoreType extends StreamBufferStore<StoreType, SpecType>, SpecType> {
	
	public final Class<StoreType> type;
	public final Class<SpecType> programSpecType;
	
	public StreamBufferStoreFactory(final Class<StoreType> type, final Class<SpecType> programSpecType) {
		super();
		this.type = type;
		this.programSpecType = programSpecType;
	}
	
	public abstract StoreType make();
	
	public abstract CompilerFactory<DTSA_Program, SpecType> DTSASpecCompiler();
	
}
