package de.lmu.ifi.pms.cep.event_mill.execution.scheduler;

import de.lmu.ifi.pms.cep.event_mill.execution.program.ExecutableProgram;
import de.lmu.ifi.pms.cep.event_mill.execution.program.ExecutableQuery;
import de.lmu.ifi.pms.cep.tsa.DTSA_QueryType;
import de.lmu.ifi.pms.java.util.collection.AbstractCollection;
import de.lmu.ifi.pms.java.util.collection.Collection;
import de.lmu.ifi.pms.java.util.collection.array.fixed.FixedArray;
import de.lmu.ifi.pms.java.util.collection.compatibility.ArrayList;
import de.lmu.ifi.pms.java.util.collection.composition.FixedComposedCollection;

public class BasicQuerySequencer extends QuerySequencer {

	@Override
	public AbstractCollection<? extends ExecutableQuery<?, ?>> order(final ExecutableProgram<?, ?, ?> program) {
		ArrayList<Collection<ExecutableQuery<?,?>>> queries = new ArrayList<Collection<ExecutableQuery<?,?>>>();
		for(DTSA_QueryType queryType: DTSA_QueryType.values()){
			if(queryType != DTSA_QueryType.INIT){
				@SuppressWarnings("unchecked")
				FixedArray<ExecutableQuery<?,?>> executableQueries = (FixedArray<ExecutableQuery<?,?>>)program.Queries().get(queryType);
				queries.add(executableQueries);
			}
		}
		//fixed round of all queries in arbitary sequence
		return new FixedComposedCollection<ExecutableQuery<?,?>>(queries);
	}

}
