package de.lmu.ifi.pms.cep.event_mill.io.bus;

import org.simpleframework.xml.Attribute;
import org.simpleframework.xml.Element;
import org.simpleframework.xml.Path;

import de.lmu.ifi.pms.cep.event_mill.io.format.MessageFormatProvider;


public class PipeMessageBusProvider<MessageType> extends SimpleMessageBusProvider<MessageType> {
	
	@Element(name="format")
	final MessageFormatProvider<MessageType> formater;
	
	@Attribute(name="ref")
	@Path(value="resource[1]")
	final String identifier1;
	@Attribute(name="ref")
	@Path(value="resource[2]")
	final String identifier2;
	
	final PipeMessageBus<MessageType> pipe1;
	final PipeMessageBus<MessageType> pipe2;
	
	public PipeMessageBusProvider(@Element(name="format") final MessageFormatProvider<MessageType> formater
			, @Attribute(name="iri") final String identifier
			, @Attribute(name="ref") @Path(value="resource[1]") final String identifier1
			, @Attribute(name="ref") @Path(value="resource[2]") final String identifier2
			) {
		super(formater.type, identifier);
		this.formater = formater;
		this.identifier1 = identifier1;
		this.identifier2 = identifier2;
		
		this.pipe1 = new PipeMessageBus<MessageType>(this);
		this.pipe2 = this.pipe1.complement;
	}
	
	@Override
	public boolean accepts(final String identifier) {
		return identifier.equals(this.identifier1) | identifier.equals(this.identifier2);
	}
	
	@Override
	public synchronized MessageBus<MessageType> connect(final String identifier) {
		if(identifier.equals(this.identifier1)){
			return this.pipe1;
		} else if(identifier.equals(this.identifier2)){
			return this.pipe2;
		}
		else{
			throw new IllegalArgumentException();
		}
	}

}
