package de.lmu.ifi.pms.cep.event_mill.io.format;

import de.lmu.ifi.pms.cep.tsa.schema.BasicTypeID;
import de.lmu.ifi.pms.java.util.collection.array.fixed.FixedArray;
import de.lmu.ifi.pms.java.util.map.fixed.FixedArrayNavigableMap;

public abstract class MessageGenerator<MessageType> extends ParameterObject{
	
	public final Class<MessageType> type;
	
	public MessageGenerator(final Class<MessageType> type, final FixedArrayNavigableMap<String, BasicTypeID> types) {
		super(types);
		this.type = type;
	}

	public MessageGenerator(final Class<MessageType> type, final FixedArray<String> parameters, final FixedArray<BasicTypeID> types) {
		super(parameters, types);
		this.type = type;
	}

	public abstract MessageType compose();
	
	public abstract void clearParameters();
	
	public abstract void setNull(final int parameterIndex, final int sqlType);
	
	public abstract void setBoolean(final int parameterIndex, final boolean value);
	
	public abstract void setByte(final int parameterIndex, final byte value);
	
	public abstract void setShort(final int parameterIndex, final short value);
	
	public abstract void setInt(final int parameterIndex, final int value);
	
	public abstract void setLong(final int parameterIndex, final long value);
	
	public abstract void setTimestamp(final int parameterIndex, final long value);
	
	public abstract void setDuration(final int parameterIndex, final long value);
	
	public abstract void setIdentifier(final int parameterIndex, final long value);
	
	public abstract void setFloat(final int parameterIndex, final float value);
	
	public abstract void setDouble(final int parameterIndex, final double value);
	
	public abstract void setString(final int parameterIndex, final String value);
	
	public void setString(final String parameter, final String value) {
		this.setString(this.indexOf(parameter), value);
	}
	
	public void setBoolean(final String parameter, final boolean value) {
		this.setBoolean(this.indexOf(parameter), value);
	}
	
	public void setByte(final String parameter, final byte value) {
		this.setByte(this.indexOf(parameter), value);
	}
	
	public void setShort(final String parameter, final short value) {
		this.setShort(this.indexOf(parameter), value);
	}
	
	public void setInt(final String parameter, final int value) {
		this.setInt(this.indexOf(parameter), value);
	}
	
	public void setLong(final String parameter, final long value) {
		this.setLong(this.indexOf(parameter), value);
	}
	
	public void setTimestamp(final String parameter, final long value) {
		this.setTimestamp(this.indexOf(parameter), value);
	}
	
	public void setDuration(final String parameter, final long value) {
		this.setDuration(this.indexOf(parameter), value);
	}
	
	public void setIdentifier(final String parameter, final long value) {
		this.setIdentifier(this.indexOf(parameter), value);
	}

	public void setFloat(final String parameter, final float value) {
		this.setFloat(this.indexOf(parameter), value);
	}

	public void setDouble(final String parameter, final double value) {
		this.setDouble(this.indexOf(parameter), value);
	}

}
