package de.lmu.ifi.pms.cep.event_mill.io.stream;

import de.lmu.ifi.pms.cep.tsa.schema.BasicTypeID;
import de.lmu.ifi.pms.java.LoggingObject;
import de.lmu.ifi.pms.java.util.collection.array.fixed.FixedArrayNavigableSet;
import de.lmu.ifi.pms.java.util.map.fixed.FixedArrayNavigableMap;



public abstract class StreamIO extends LoggingObject{
	
	public final String identifier;
		
	public StreamIO(final String identifier){
		super();
		this.identifier = identifier;
	}
	
	public abstract FixedArrayNavigableSet<String> sinkNames();
	
	public FixedArrayNavigableMap<String, BasicTypeID> sinkTypes(final String name){
		return this.sinkStream(name).types;
	}
	
	public SinkStream sinkStream(final String name){
		return this.newSinkStream(name);
	}
	
	protected abstract SinkStream newSinkStream(String name);

	public SinkStream[] sinkStreams(){
		FixedArrayNavigableSet<String> buffers = this.sinkNames();		
		SinkStream[] sinkStreams = new SinkStream[buffers.size()];
		for(int buffer = 0; buffer < sinkStreams.length; ++buffer){
			sinkStreams[buffer] = this.sinkStream(buffers.get(buffer));
		}
		return sinkStreams;
	}
	
	public abstract FixedArrayNavigableSet<String> sourceNames();
	
	public FixedArrayNavigableMap<String, BasicTypeID> sourceTypes(final String name){
		return this.sourceStream(name).types;
	}
	
	public SourceStream sourceStream(final String name){
		return this.newSourceStream(name);
	}
	
	protected abstract SourceStream newSourceStream(String name);
	
	public SourceStream[] sourceStreams(){
		FixedArrayNavigableSet<String> buffers = this.sourceNames();		
		SourceStream[] sourceStreams = new SourceStream[buffers.size()];
		for(int buffer = 0; buffer < sourceStreams.length; ++buffer){
			sourceStreams[buffer] = this.sourceStream(buffers.get(buffer));
		}
		return sourceStreams;
	}
	
	public synchronized void close(){

	}

	@Override
	protected void finalize() throws Throwable {
		this.close();
	}

}
