package de.lmu.ifi.pms.cep.event_mill.io.stream;

import org.simpleframework.xml.Attribute;
import org.simpleframework.xml.Root;

@Root(name="stream")
public abstract class StreamIOProvider{
	
	@Attribute(name="iri", required=false)
	public final String identifier;
	
	public StreamIOProvider(final String identifier) {
		super();
		if(identifier == null){
			throw new IllegalArgumentException("Requires valid identifier. \"null\" is not permitted.");
		}
		this.identifier = identifier;
	}
	
	public abstract boolean accepts(String identity);

	public abstract StreamIO connect(String identity);
	
}
