-- setup database
CREATE SCHEMA "meta";

CREATE TABLE "meta"."program_specs" (
	"id" INT AUTO_INCREMENT PRIMARY KEY,
	"namespace" CLOB NOT NULL,
	"simple_name" CLOB NOT NULL,
	"description" CLOB,
	"xml_buffer_specs" CLOB,
	"type_definitions_database" CLOB, 
	"xml_query_specs" CLOB,
	"rule_definitions_database" CLOB,
	CONSTRAINT "program_spec_unique_name" UNIQUE ("program_spec_namespace", "program_spec_simple_name")
);

CREATE TABLE "meta"."programs" (
	"id" INT AUTO_INCREMENT PRIMARY KEY,
	"spec_ref" INT REFERENCES "meta"."program_specifications" ON UPDATE CASCADE,
	"instance" CLOB NOT NULL DEFAULT '',
	"meta_schema_name" CLOB NOT NULL,
	"input_buffer_schema_name" CLOB NOT NULL,
	"working_buffer_schema_name" CLOB NOT NULL,
	"output_buffer_schema_name" CLOB NOT NULL,
	"log_schema_name"  CLOB NOT NULL,
	"state" VARCHAR(10) DEFAULT 'UNLOCKED' NOT NULL, --allowed values 'UNLOCKED', 'LOCKED'
	CONSTRAINT "program_unique_name" UNIQUE ("spec_ref", "instance"),
);

--TODO check correct order of state updates

--CREATE FUNCTION "raiserror" ("msg" CLOB) RETURNS BOOLEAN EXTERNAL NAME sql.raiserror;

--function sql.raiserror(:str):bit;

CREATE FUNCTION "row_max" ("m" BIGINT, "n" BIGINT) RETURNS BIGINT IF ( "m" > "n" ) THEN RETURN "m"; ELSE RETURN "n"; END IF;

CREATE FUNCTION "row_min" ("m" BIGINT, "n" BIGINT) RETURNS BIGINT IF ( "m" < "n" ) THEN RETURN "m"; ELSE RETURN "n"; END IF;
