package de.lmu.ifi.pms.cep.tsa.compiler;

import static de.lmu.ifi.pms.cep.tsa.schema.BasicTypeID.*;

import org.simpleframework.xml.Attribute;

import de.lmu.ifi.pms.cep.tsa.time.analysis.ArithmeticAnalyserFactory;
import de.lmu.ifi.pms.cep.tsa.time.analysis.SimpleArithmeticAnalyzerFactory;

public class TSA_DefaultDifferencerFactory extends TSA_DifferencerFactory {
	
	//FIXME serialization
	final ArithmeticAnalyserFactory identifierAnalyserFactory;
	final ArithmeticAnalyserFactory temporalAnalyserFactory;
	
	public static final String defaultIdentifier = "de.lmu.ifi.pms.cep.tsa.differencer.default";
	
	public TSA_DefaultDifferencerFactory(){
		this(defaultIdentifier);
	}
	
	public TSA_DefaultDifferencerFactory(@Attribute(name="iri", required=true) final String identifier){
		this(identifier, new SimpleArithmeticAnalyzerFactory(IDENTIFIER), new SimpleArithmeticAnalyzerFactory(TIMESTAMP));
	}
	
	public TSA_DefaultDifferencerFactory(@Attribute(name="iri", required=true) final String identifier
			, final ArithmeticAnalyserFactory identifierAnalyserFactory
			, final ArithmeticAnalyserFactory temporalAnalyserFactory) {
		super(identifier);
		this.identifierAnalyserFactory = identifierAnalyserFactory;
		this.temporalAnalyserFactory = temporalAnalyserFactory;
	}
	
	@Override
	public TSA_Differencer make() {
		return new TSA_DefaultDifferencer(this.identifierAnalyserFactory, this.temporalAnalyserFactory);
	}

}
