package de.lmu.ifi.pms.cep.tsa.conditions;

import de.lmu.ifi.pms.cep.tsa.schema.AType;
import de.lmu.ifi.pms.java.util.adaption.Adapter;

public abstract class AtomicTerm<TypeClass extends AType> extends Term<TypeClass> {
	
	@SuppressWarnings("hiding")
	public final AtomicTermID ID;

	public AtomicTerm(final AtomicTermID ID, final TypeClass type) {
		super(TermID.ATOMIC, type);
		this.ID = ID;
	}
	
	@Override
	public Term<?> replaceAtomicTerm(final Adapter<? super AtomicTerm<?>, ? extends Term<?>> replacement) {
		return replacement.adapt(this);
	}

}
