package de.lmu.ifi.pms.cep.tsa.conditions;

import org.simpleframework.xml.Text;

public class ConstantLiteral extends UntypedConstant {

	@Text
	public final String literal;

	public ConstantLiteral(@Text final String literal) {
		super();
		this.literal = literal;
	}
	
	@Override
	protected int compareToImpl(final Term<?> o) {
		int cmp = super.compareToImpl(o);
		if(cmp == 0){
			cmp = this.literal.compareTo(((ConstantLiteral)o).literal);
		}
		return cmp;
	}
	
	@Override
	protected boolean equalsImpl(final Object o) {
		if(this.getClass() == o.getClass()){
			return this.literal.equals(((ConstantLiteral)o).literal);
		}
		else{
			return false;
		}
	}
	
	@Override
	public int hashCode() {
		return super.hashCode() ^ this.literal.hashCode();
	}
	
	@Override
	public String toString() {
		return this.literal;
	}
}
