package de.lmu.ifi.pms.cep.tsa.conditions;

import org.simpleframework.xml.Element;
import org.simpleframework.xml.ElementList;
import org.simpleframework.xml.Root;

import de.lmu.ifi.pms.cep.tsa.schema.CompositeType;


@Root(name="tuple")
public class DataTypeRecord extends Record<CompositeType> {
	
	private DataTypeRecord(final CompositeType type) {
		super(type, type.attributes.keys());
	}
	
	public DataTypeRecord(@Element(name="type", required=false) final CompositeType type, @ElementList(entry="term", inline=true, required=false, empty=false)  final java.util.ArrayList<Term<?>> arguments) {
		this(type, arguments.toArray(new Term<?>[arguments.size()]));
	}
	
	public DataTypeRecord(final CompositeType type, final Term<?>... arguments) {
		this(type, true, arguments);
	}
	
	protected DataTypeRecord(final CompositeType type, final boolean copy, final Term<?>... arguments) {
		super(type, type.attributes.keys(), copy, arguments);
	}
	
	@Override
	public DataTypeRecord newTerm(final Term<?>... arguments){
		return new DataTypeRecord(this.type, arguments);
	}

}
