package de.lmu.ifi.pms.cep.tsa.conditions;

import de.lmu.ifi.pms.cep.tsa.schema.CompositeType;
import de.lmu.ifi.pms.java.util.collection.array.fixed.FixedArray;
import de.lmu.ifi.pms.java.util.map.fixed.FixedArrayNavigableMap;

public class DataTypeValue extends Value<CompositeType> {
	
	public final FixedArrayNavigableMap<String, Value<?>> attributeValues;

	public DataTypeValue(final CompositeType type, final FixedArrayNavigableMap<String, Value<?>> values) {
		super(type);
		this.attributeValues = values;
		//TODO check value types
		int numberOfAttributes = type.attributes.size();
		if(numberOfAttributes == this.attributeValues.size()){
			for(int attribute = 0; attribute < numberOfAttributes; ++attribute){
				if(type.attributes.keys().get(attribute).equals(this.attributeValues.keys().get(attribute))){
					if(type.attributes.values().get(attribute).equals(this.attributeValues.values().get(attribute))){
						continue;
					}
					else{
						throw new IllegalArgumentException();
						//TODO better exception
					}
				}
				else{
					throw new IllegalArgumentException();
					//TODO better exception
				}
			}
		}
		else{
			throw new IllegalArgumentException();
			//TODO better exception
		}
	}
	
	@Override
	protected int compareValue(final Value<CompositeType> value) {
		assert this.type.equals(value.type);
		int cmp = 0;
		FixedArray<Value<?>> own_values = this.attributeValues.values();
		FixedArray<Value<?>> other_values = this.attributeValues.values();
		assert own_values.size() == other_values.size();
		int attribute = 0;
		int numberOfAttributes = own_values.size();
		while(cmp == 0 & attribute < numberOfAttributes){
			cmp = own_values.get(attribute).compareTo(other_values.get(attribute));
			++attribute;
		}
		return cmp;
	}
	
	@Override
	public int valueHashcode() {
		int hashcode =  super.hashCode();
		for(Value<?> value: this.attributeValues.values()){
			hashcode ^= value.hashCode();
		}
		return hashcode;
	}

	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("{");
		if(this.attributeValues.size() > 0){
			for(int argument = 0; argument < this.attributeValues.size(); ++argument){
				sb.append(this.attributeValues.keys().get(argument));
				sb.append("{ ");
				sb.append(this.attributeValues.values().get(argument));
				sb.append(" }");
				sb.append(", ");
			}
			sb.setLength(sb.length() - ", ".length());
		}
		sb.append("}");
		return sb.toString();
	}
	
}
