package de.lmu.ifi.pms.cep.tsa.conditions;

import org.simpleframework.xml.Element;
import org.simpleframework.xml.ElementList;

import de.lmu.ifi.pms.cep.tsa.schema.AType;
import de.lmu.ifi.pms.cep.tsa.schema.NoType;


public class Greatest<TypeClass extends AType> extends TupleFunction<TypeClass> {

	public Greatest(final TypeClass type, final Term<?>... arguments) {
		super(TupleFunctionID.GREATEST, type, arguments);
	}
	
	@SuppressWarnings("unchecked")
	Greatest(@Element(name="type", required=false) final TypeClass type, @ElementList(entry="term", inline=true, required=false, empty=false)  final java.util.ArrayList<Term<?>> arguments) {
		super(TupleFunctionID.GREATEST, (type==null ? (TypeClass)NoType.instance : type), arguments);
	}
	
	@Override
	public Greatest<TypeClass> newTerm(final Term<?>... arguments) {
		return new Greatest<TypeClass>(this.type, arguments);
	}

}
