package de.lmu.ifi.pms.cep.tsa.conditions;

import de.lmu.ifi.pms.cep.tsa.schema.NamedType;
import de.lmu.ifi.pms.cep.tsa.schema.NamelessType;

public class NamedTypeValue<TypeClass extends NamelessType> extends Value<NamedType<TypeClass>> {
	
	public final Value<TypeClass> value;

	public NamedTypeValue(final NamedType<TypeClass> type, final Value<TypeClass> value) {
		super(type);
		this.value = value;
	}
	
	
	@Override
	protected int compareValue(final Value<NamedType<TypeClass>> value) {
		return this.value.compareTo(((NamedTypeValue<TypeClass>)value).value);
	}
	
	@Override
	protected int valueHashcode() {
		return this.value.hashCode();
	}
	
	@Override
	public String toString() {
		return String.format("%s : %s", this.value.toString(), this.type.toString());
	}

}
