package de.lmu.ifi.pms.cep.tsa.conditions;

import org.simpleframework.xml.Element;
import org.simpleframework.xml.ElementList;

import de.lmu.ifi.pms.cep.tsa.schema.AType;
import de.lmu.ifi.pms.cep.tsa.schema.NoType;


public class Power<TypeClass extends AType> extends TupleFunction<TypeClass> {

	public Power(final TypeClass type, final Term<?> argument1, final Term<?> argument2) {
		super(TupleFunctionID.POWER, type, argument1, argument2);
	}
	
	@SuppressWarnings("unchecked")
	Power(@Element(name="type", required=false) final TypeClass type, @ElementList(entry="term", inline=true, required=false, empty=false)  final java.util.ArrayList<Term<?>> arguments) {
		super(TupleFunctionID.POWER, (type==null ? (TypeClass)NoType.instance : type), arguments);
	}
	
	@Override
	public Power<TypeClass> newTerm(final Term<?>... arguments) {
		return new Power<TypeClass>(this.type, arguments[0],arguments[1]);
	}

}