package de.lmu.ifi.pms.cep.tsa.conditions.adaptor;

import de.lmu.ifi.pms.cep.tsa.conditions.AtomicTerm;
import de.lmu.ifi.pms.cep.tsa.conditions.NamedConstant;
import de.lmu.ifi.pms.cep.tsa.conditions.TypedNamedConstant;
import de.lmu.ifi.pms.java.util.adaption.Adapter;
import de.lmu.ifi.pms.java.util.map.fixed.FixedArrayNavigableMap;

public class RenameConstants implements Adapter<AtomicTerm<?>, AtomicTerm<?>>{
	
	public final FixedArrayNavigableMap<String, String> mapping;
	
	public RenameConstants(final FixedArrayNavigableMap<String, String> mapping) {
		super();
		this.mapping = mapping;
	}

	@Override
	public AtomicTerm<?> adapt(final AtomicTerm<?> source) {
		if(source instanceof NamedConstant){
			NamedConstant constant = (NamedConstant) source;
			int index = this.mapping.keys().indexOf(constant.name);
			if(index >= 0){
				return constant.rename(this.mapping.values().get(index));
			}
			else{
				return source;
			}
		}
		else if(source instanceof TypedNamedConstant<?>){
			TypedNamedConstant<?> constant = (TypedNamedConstant<?>) source;
			int index = this.mapping.keys().indexOf(constant.name);
			if(index >= 0){
				return constant.rename(this.mapping.values().get(index));
			}
			else{
				return source;
			}
		}
		else{
			return source;
		}
	}

}
