package de.lmu.ifi.pms.cep.tsa.time.analysis;

import de.lmu.ifi.pms.cep.tsa.schema.BasicType;
import de.lmu.ifi.pms.cep.tsa.schema.BasicTypeID;
import de.lmu.ifi.pms.cep.tsa.time.ArithmeticRelationFormulaExtractor;
import de.lmu.ifi.pms.cep.tsa.time.constraints.TemporalRelationFormula;
import de.lmu.ifi.pms.java.util.collection.array.fixed.FixedArrayNavigableSet;

public class SimpleArithmeticAnalyzerFactory extends ArithmeticAnalyserFactory{
	
	
	
	public SimpleArithmeticAnalyzerFactory(final ArithmeticRelationFormulaExtractor formulaExtractor) {
		super(formulaExtractor);
	}

	public SimpleArithmeticAnalyzerFactory(final BasicType type) {
		super(type);
	}

	public SimpleArithmeticAnalyzerFactory(final BasicTypeID type) {
		super(type);
	}

	@Override
	public SimpleArithmeticAnalyzer make(final TemporalRelationFormula f){
		return new SimpleArithmeticAnalyzer(f);
	}
	
	@Override
	public ArithmeticAnalyser make(final TemporalRelationFormula temporalRelationFormula, final FixedArrayNavigableSet<String> relevantAttributes, final FixedArrayNavigableSet<String> relevantVariables) {
		return new SimpleArithmeticAnalyzer(temporalRelationFormula, relevantAttributes, relevantVariables);
	}
	
}
