package de.lmu.ifi.pms.java.lang.iteration;

import java.util.Iterator;
import java.util.SortedMap;
import java.util.TreeMap;

public class TreeMapIterable<KeyType, ValueType>  implements Iterable<TreeMap<KeyType, ValueType>>{

	private final SortedMap<KeyType, ? extends Iterable<ValueType>> iterableMap;
	
	public TreeMapIterable(final SortedMap<KeyType, ? extends Iterable<ValueType>> iterableMap) {
		this.iterableMap = iterableMap;
	}
	
	@Override
	public Iterator<TreeMap<KeyType, ValueType>> iterator() {
		return new TreeMapIterator<KeyType, ValueType>(this.iterableMap);
	}
	
}
