package de.lmu.ifi.pms.java.util.collection.array;

import de.lmu.ifi.pms.java.lang.iteration.AbstractModifyableIterator;

public class ArrayIterator<Type> extends AbstractModifyableIterator<Type>{
	
	private final Type[] array;
	private int position;	
	private final int length;
	
	public ArrayIterator(final Type[] array){
		this(array, 0, array.length);
	}

	public ArrayIterator(final Type[] array, final int offset, final int length) {
		super();
		this.array = array;
		this.position = offset;
		this.length = length;
	}

	@Override
	public boolean hasNext() {
		return this.position < this.length;
	}

	@Override
	public Type next() {
		return this.array[this.position++];
	}
	
	@Override
	public void replace(final Type newValue) {
		this.array[this.position - 1] = newValue;
	}
	
}
