/**
 * 
 */
package de.lmu.ifi.pms.java.util.collection.compatibility;

import java.util.Comparator;

import de.lmu.ifi.pms.java.util.collection.javaWrapper.FromJavaExtendibleNavigableSetWrapper;
import de.lmu.ifi.pms.java.util.collection.set.Set;
import de.lmu.ifi.pms.java.util.collection.set.SortedSet;


/**
 * @author Simon Matthias Brodt
 *
 */
public class TreeSet<Type> extends FromJavaExtendibleNavigableSetWrapper<Type>{

	public TreeSet() {
		super(new java.util.TreeSet<Type>());
	}
	
	public TreeSet(final Comparator<? super Type> comparator) {
		super(new java.util.TreeSet<Type>(comparator));
	}
	
	public TreeSet(final Set<? extends Type> set) {
		super(new java.util.TreeSet<Type>(set.javaCollection()));
	}
	
	public TreeSet(final java.util.Set<? extends Type> set) {
		super(new java.util.TreeSet<Type>(set));
	}
	
	public TreeSet(final SortedSet<? extends Type> set) {
		super(new java.util.TreeSet<Type>(set.javaCollection()));
	}
	
	public TreeSet(final java.util.SortedSet<? extends Type> set) {
		super(new java.util.TreeSet<Type>(set));
	}


}
