/**
 * 
 */
package de.lmu.ifi.pms.java.util.collection.extendible.list;

/**
 * @author Simon Matthias Brodt
 *
 */
public abstract class AbstractDoubleLinkedList<Type, ListEntryType extends DoubleLinkedListEntry<Type, ListEntryType>> extends AbstractSingleLinkedList<Type, ListEntryType> {
	
	final ListEntryType foot;

	public AbstractDoubleLinkedList() {
		super();
		this.foot = newListFoot(this.head);
	}
	
	@Override
	public abstract ListEntryType newListHead(AbstractSingleLinkedList<Type, ListEntryType> linkingList);
	
	public abstract ListEntryType newListFoot(ListEntryType head);
	
	@Override
	public abstract ListEntryType newUnlinkedEntry(Type value);
	
	
	public boolean addFirst(Type value) {
		insertBehind(this.foot, newUnlinkedEntry(value));
		return true;
	}
	
	public Type first(){
		return value(next(this.foot));
	}
	
	public void removeFirst(){
		removeNext(this.foot);
	}
	
	protected ListEntryType next(ListEntryType entry){
		return entry.next();
	}
	
	protected void insertBehind(ListEntryType entry, ListEntryType newEntry){
		newEntry.insertBehind(entry);
	}
	
	protected void removeNext(ListEntryType entry){
		entry.removeNext();
	}
	
	protected void removeFollowing(ListEntryType entry){
		entry.removeFollowing();
	}

}
