package de.lmu.ifi.pms.java.util.collection.fixed.empty;

import java.util.NoSuchElementException;

import de.lmu.ifi.pms.java.lang.iteration.AbstractFixedIterator;



public class EmptyIterator<Type> extends AbstractFixedIterator<Type>{
	
	@SuppressWarnings("rawtypes")
	private static EmptyIterator emptyIterator = new EmptyIterator();
	
	@SuppressWarnings("unchecked")
	public static final <Type> EmptyIterator<Type> instance(){
		return emptyIterator;
	}
	
	protected EmptyIterator() {
		super();
	}
	
	@Override
	public final Type next() {
		throw new NoSuchElementException();
	}
	
	@Override
	public final boolean hasNext() {
		return false;
	}
	
	
}
