package de.lmu.ifi.pms.java.util.collection.fixed.wrapper;

import java.util.List;

import de.lmu.ifi.pms.java.lang.iteration.AbstractFinalListIterator;
import de.lmu.ifi.pms.java.lang.iteration.FinalListIteratorWrapper;
import de.lmu.ifi.pms.java.util.collection.fixed.AbstractFixedList;


public class FixedListWrapper<Type> extends AbstractFixedList<Type> {

	private final List<Type> collection;	
	
	public FixedListWrapper(final List<Type> collection) {
		super();
		this.collection = collection;
	}

	@Override
	public final int size() {
		return this.collection.size();
	}

	@Override
	public Type get(final int index) {
		return this.collection.get(index);
	}

	@Override
	public int indexOf(final Object o) {
		return this.collection.indexOf(o);
	}

	@Override
	public int lastIndexOf(final Object o) {
		return this.collection.lastIndexOf(o);
	}

	@Override
	public AbstractFinalListIterator<Type> listIterator() {
		return new FinalListIteratorWrapper<Type>(this.collection.listIterator());
	}

	@Override
	public AbstractFinalListIterator<Type> listIterator(final int index) {
		return new FinalListIteratorWrapper<Type>(this.collection.listIterator(index));
	}

	@Override
	public AbstractFixedList<Type> subList(final int fromIndex, final int toIndex) {
		return new FixedListWrapper<Type>(this.collection.subList(fromIndex, toIndex));
	}
	
	
	
}
