package de.lmu.ifi.pms.java.util.collection.fixed.wrapper;

import java.util.Comparator;
import java.util.NavigableSet;

import de.lmu.ifi.pms.java.lang.iteration.AbstractFixedIterator;
import de.lmu.ifi.pms.java.lang.iteration.FinalIteratorWrapper;
import de.lmu.ifi.pms.java.util.collection.fixed.set.AbstractFixedNavigableSet;
import de.lmu.ifi.pms.java.util.collection.fixed.set.FixedNavigableSet;
import de.lmu.ifi.pms.java.util.collection.fixed.set.FixedSortedSet;


public class FixedNavigableSetWrapper<Type> extends AbstractFixedNavigableSet<Type>{

private final NavigableSet<Type> collection;	
	
	public FixedNavigableSetWrapper(final NavigableSet<Type> collection) {
		super();
		this.collection = collection;
	}

	@Override
	public final AbstractFixedIterator<Type> iterator() {
		return new FinalIteratorWrapper<Type>(this.collection.iterator());
	}

	@Override
	public final int size() {
		return this.collection.size();
	}

	@Override
	public Comparator<? super Type> comparator() {
		return this.collection.comparator();
	}

	@Override
	public final Type first() {
		return this.collection.first();
	}

	@Override
	public final FixedSortedSet<Type> headSet(final Type toElement) {
		return new FixedSortedSetWrapper<Type>(this.collection.headSet(toElement));
	}

	@Override
	public final Type last() {
		return this.collection.last();
	}

	@Override
	public final FixedSortedSet<Type> subSet(final Type fromElement, final Type toElement) {
		return new FixedSortedSetWrapper<Type>(this.collection.subSet(fromElement, toElement));
	}

	@Override
	public final FixedSortedSet<Type> tailSet(final Type fromElement) {
		return new FixedSortedSetWrapper<Type>(this.collection.tailSet(fromElement));
	}

	@Override
	public final AbstractFixedIterator<Type> descendingIterator() {
		return new FinalIteratorWrapper<Type>(this.collection.descendingIterator());
	}

	@Override
	public final FixedNavigableSet<Type> descendingSet() {
		return new FixedNavigableSetWrapper<Type>(this.collection.descendingSet());
	}

	@Override
	public final FixedNavigableSet<Type> headSet(final Type toElement, final boolean inclusive) {
		return new FixedNavigableSetWrapper<Type>(this.collection.headSet(toElement, inclusive));
	}

	@Override
	public final FixedNavigableSet<Type> subSet(final Type fromElement, final boolean fromInclusive, final Type toElement, final boolean toInclusive) {
		return new FixedNavigableSetWrapper<Type>(this.collection.subSet(fromElement, fromInclusive, toElement, toInclusive));
	}

	@Override
	public final FixedNavigableSet<Type> tailSet(final Type fromElement, final boolean inclusive) {
		return new FixedNavigableSetWrapper<Type>(this.collection.tailSet(fromElement, inclusive));
	}

	@Override
	public final Type ceiling(final Type e) {
		return this.collection.ceiling(e);
	}

	@Override
	public final Type floor(final Type e) {
		return this.collection.floor(e);
	}

	@Override
	public final Type higher(final Type e) {
		return this.collection.higher(e);
	}

	@Override
	public final Type lower(final Type e) {
		return this.collection.lower(e);
	}



}
