package de.lmu.ifi.pms.java.util.collection.set;

import java.util.Iterator;


public interface NavigableSet<Type> extends SortedSet<Type>{

	public Type ceiling(Type e);
	
	public Type floor(Type e);
	
	public Type higher(Type e);
	
	public Type lower(Type e);
	
	public NavigableSet<Type> headSet(Type toElement, boolean inclusive);
	
	public NavigableSet<Type> subSet(Type fromElement, boolean fromInclusive, Type toElement, boolean toInclusive);
	
	public NavigableSet<Type> tailSet(Type fromElement, boolean inclusive);
	
	public NavigableSet<Type> descendingSet();
	
	public Iterator<Type> descendingIterator();
	
	@Override
	public java.util.NavigableSet<Type> javaCollection();
	
}
