/**
 * 
 */
package de.lmu.ifi.pms.java.util.map;

/**
 * @author Simon Matthias Brodt
 *
 */
public abstract class Entry1<KeyType, ValueType> extends AbstractExtendibleEntry<KeyType, ValueType>{
	
	protected final KeyType key;
	
	protected boolean removed = false;
	
	public Entry1(KeyType key){
		this(key, true);
	}

	protected Entry1(KeyType key, boolean removed) {
		super();
		this.key = key;
		this.removed = removed;
	}

	@Override
	public KeyType key(){
		return this.key;
	}
	
	@Override
	public boolean isRemoved() {
		return this.removed;
	}
	
	@Override
	public final void remove(){
		if(this.removed){
			throw new IllegalStateException();
		}
		else{
			removeAction();
			this.removed = true;
		}
	}
	
	public void removeAction(){
		throw new UnsupportedOperationException();
	}
	
}
