/**
 * 
 */
package de.lmu.ifi.pms.java.util.map;

import de.lmu.ifi.pms.java.lang.iteration.Iterator;
import de.lmu.ifi.pms.java.util.collection.Collection;
import de.lmu.ifi.pms.java.util.collection.set.Set;

/**
 * @author Simon Matthias Brodt
 *
 */
public interface Map<KeyType, ValueType, EntryType extends Entry<KeyType, ValueType>> extends Set<EntryType>{
	
	ValueType get(KeyType key);
	
	EntryType entry(KeyType key);
	
	boolean has(KeyType key);
	
	@Deprecated
	boolean containsKey(Object key);
	
	Set<KeyType> keys();
	
	@Deprecated
	Set<KeyType> keySet();
	
	Collection<ValueType> values();
	
	@Override
	boolean contains(Object o);
	
	@Override
	boolean containsAll(Collection<?> c);
	
	@Override
	boolean isEmpty();
	
	@Override
	Iterator<EntryType> iterator();
	
	@Override
	int size();
	
	public java.util.Map<KeyType, ValueType> javaMap();
	
	@Override
	Object[] toArray();
	
	@Override
	<T> T[] toArray(T[] a);
	
	@Deprecated
	Set<EntryType> entrySet();
	
}
