/**
 * 
 */
package de.lmu.ifi.pms.java.util.map.fixed;

import de.lmu.ifi.pms.java.util.collection.array.fixed.FixedArray;
import de.lmu.ifi.pms.java.util.collection.array.fixed.FixedArraySet;
import de.lmu.ifi.pms.java.util.collection.set.Set;
import de.lmu.ifi.pms.java.util.map.Map;

/**
 * @author Simon Matthias Brodt
 *
 */
public class FixedArrayMap<KeyType, ValueType> extends AbstractFixedArrayMap<KeyType, ValueType, FixedArraySet<KeyType>> {
	
	public FixedArrayMap() {
		super();
	}

	public FixedArrayMap(final boolean emptyBody) {
		super(emptyBody);
	}

	public FixedArrayMap(final FixedArraySet<KeyType> keys, final FixedArray<? extends ValueType> values) {
		super(keys, values);
	}
	
	public FixedArrayMap(final KeyType[] keys, final ValueType[] values) {
		this(true, keys, values);
	}
	
	//FIXME Currently key set Unchecked
	public FixedArrayMap(final boolean copy, final KeyType[] keys, final ValueType[] values) {
		this(new FixedArraySet<KeyType>(copy, keys), new FixedArray<ValueType>(copy, values));
	}

	public FixedArrayMap(final Map<KeyType, ValueType, ?> map) {
		super(map);
	}

	/* (non-Javadoc)
	 * @see extension.java.util.map.fixed.AbstractFixedArrayMap#newKeySet(extension.java.util.collection.set.Set)
	 */
	@Override
	protected FixedArraySet<KeyType> newKeySet(final Set<KeyType> keys) {
		return new FixedArraySet<KeyType>(keys);
	}
	
}
