package de.lmu.ifi.pms.java.util.stream;

import de.lmu.ifi.pms.java.lang.iteration.ExaminingIteratorWrapper;

public class ExaminingStreamWrapper<Type> implements SourceStream<Type>{

	private final SourceStream<Type> stream;
	
	public ExaminingStreamWrapper(final SourceStream<Type> stream) {
		super();
		this.stream = stream;
	}

	@Override
	public ExaminingIteratorWrapper<Type> iterator() {
		return new ExaminingIteratorWrapper<Type>(this.stream.iterator());
	}
	
	@Override
	public Source<Type> source() {
		return this.iterator();
	}
	
	@Override
	public void close(){
		 this.stream.close();
	}
	
}
