package de.lmu.ifi.pms.java.util.stream.io;

import java.io.Closeable;

import de.lmu.ifi.pms.java.lang.iteration.AbstractFixedIterator;
import de.lmu.ifi.pms.java.util.stream.Source;
import de.lmu.ifi.pms.java.util.stream.SourceStream;
import de.lmu.ifi.pms.java.util.tupel.Tupel;


public abstract class ObjectInputStream<Type, ResourceTupelType extends Tupel<? extends Closeable>> extends AbstractResourceCloseable<ResourceTupelType> implements SourceStream<Type>{

	public ObjectInputStream() {
		super();
	}

	public abstract Type readObject();
	
	public abstract boolean hasObject();
	
	@Override
	public Source<Type> iterator() {
		return new AbstractFixedIterator<Type>(){
			
			@Override
			public boolean hasNext() {
				return ObjectInputStream.this.hasObject();
			}
			
			@Override
			public Type next() {
				return ObjectInputStream.this.readObject();
			}
			
		};
	}
	
	@Override
	public Source<Type> source() {
		return this.iterator();
	}
	
}
