package de.lmu.ifi.pms.java.util.tupel;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.NoSuchElementException;

import de.lmu.ifi.pms.java.lang.iteration.AbstractFixedIterator;
import de.lmu.ifi.pms.java.util.cloneable.Cloneable;
import de.lmu.ifi.pms.java.util.collection.fixed.AbstractFixedCollection;



public class Tupel<Type> extends AbstractFixedCollection<Type> implements Serializable, Cloneable<Tupel<Type>>{

	@SuppressWarnings("rawtypes")
	private static final Tupel EMPTY = new Tupel();
	
	@SuppressWarnings("unchecked")
	public static final <Type> Tupel<Type> EMPTY(){
		return EMPTY;
	}
	
	public int componentCount(){
		return 0;
	}
	
	public Type getComp(final int i){
		throw new NoSuchElementException(); //TODO better Exception
	}
	
	public ArrayList<Type> toArrayList(){
		ArrayList<Type> array = new ArrayList<Type>(this.componentCount());
		for(int i = 0;i < this.componentCount(); ++i){
			array.add(this.getComp(i));
		}
		return array;
	}
	
	@Override
	public final int size() {
		return this.componentCount();
	}
	
	@Override
	public Tupel<Type> clone(){
		return this;
	}
	
	@Override
	public final AbstractFixedIterator<Type> iterator() {
		return new AbstractFixedIterator<Type>(){
			
			int i = 0;
			
			@Override
			public boolean hasNext() {
				return this.i < Tupel.this.componentCount();
			}
			
			@Override
			public Type next() {
				return Tupel.this.getComp(this.i++);
			}
			
		};
	}
	
	/* (non-Javadoc)
	 * @see extension.java.util.collection.AbstractCollection#openingBracket()
	 */
	@Override
	protected String openingBracket() {
		return "(";
	}
	
	/* (non-Javadoc)
	 * @see extension.java.util.collection.AbstractCollection#closingBracket()
	 */
	@Override
	protected String closingBracket() {
		return ")";
	}
	
}
