package de.lmu.ifi.pms.cep.unitTests;

import java.io.IOException;

import org.antlr.runtime.RecognitionException;

import de.lmu.ifi.pms.cep.compilation.Compiler;
import de.lmu.ifi.pms.cep.compilation.StackCompiler;
import de.lmu.ifi.pms.cep.dura.compiler.durac.DuraCCompiler;
import de.lmu.ifi.pms.cep.event_mill.sql.SQL_Program_Spec;
import de.lmu.ifi.pms.cep.event_mill.sql.compiler.DTSA_SQL_Compiler;
import de.lmu.ifi.pms.cep.event_mill.sql.compiler.DTSA_SQL_WriterImpl;
import de.lmu.ifi.pms.cep.tsa.TSA_Program;
import de.lmu.ifi.pms.cep.tsa.compiler.TSA_DTSA_Compiler;
import de.lmu.ifi.pms.cep.tsa.compiler.TSA_DefaultDifferencer;


public class DuraCCompilerTest {
	public static void main(final String[] args) throws IOException, RecognitionException {
		assert(args.length == 1);
		
		Compiler<TSA_Program, SQL_Program_Spec> tsaSQLCompiler = new StackCompiler<TSA_Program, SQL_Program_Spec>(TSA_Program.class, SQL_Program_Spec.class, new TSA_DTSA_Compiler(new TSA_DefaultDifferencer()), new DTSA_SQL_Compiler(new DTSA_SQL_WriterImpl()));

		tsaSQLCompiler.compile(DuraCCompiler.compile("testns", "test", args[0]));
	}
}
